using CMSMicroservice.Domain.Entities;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
namespace CMSMicroservice.Infrastructure.Persistence.Configurations;
//دسته بندی
public class CategoryConfiguration : IEntityTypeConfiguration<Category>
{
    public void Configure(EntityTypeBuilder<Category> builder)
    {
        builder.HasQueryFilter(p => !p.IsDeleted);
        builder.Ignore(entity => entity.DomainEvents);
        builder.HasKey(entity => entity.Id);
        builder.Property(entity => entity.Id).UseIdentityColumn();
        builder.Property(entity => entity.Name).IsRequired(true);
        builder.Property(entity => entity.Title).IsRequired(true);
        builder.Property(entity => entity.Description).IsRequired(false);
        builder.Property(entity => entity.ImagePath).IsRequired(false);
        builder
            .HasOne(entity => entity.Parent)
            .WithMany(entity => entity.Categories)
            .HasForeignKey(entity => entity.ParentId)
            .IsRequired(false);
        builder.Property(entity => entity.IsActive).IsRequired(true);
        builder.Property(entity => entity.SortOrder).IsRequired(true);

    }
}
